diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_msql.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_msql.py
new file mode 100644
index 000000000..d97a91827
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_msql.py
@@ -0,0 +1,105 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as check_constraint_utils
+
+
+class CheckConstraintGetMsqlTestCase(BaseTestGenerator):
+    """This class will fetch modified sql for check constraint of table. """
+    skip_on_database = ['gpdb']
+    url = '/browser/check_constraint/msql/'
+
+    # Generates scenarios from cast_test_data.json file
+    scenarios = utils.generate_scenarios("check_constraint_msql",
+                                         check_constraint_utils.test_cases)
+
+    def setUp(self):
+        super(CheckConstraintGetMsqlTestCase, self).setUp()
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        self.server_id = schema_info["server_id"]
+        self.db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to fetch a check "
+                            "constraint.")
+
+        # Create schema
+        self.schema_id = schema_info["schema_id"]
+        self.schema_name = schema_info["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to fetch a check "
+                            "constraint.")
+
+        # Create table
+        self.table_name = "table_checkconstraint_get_%s" % \
+                          (str(uuid.uuid4())[1:8])
+        self.table_id = tables_utils.create_table(self.server,
+                                                  self.db_name,
+                                                  self.schema_name,
+                                                  self.table_name)
+
+        # Create constraint to modify
+        self.check_constraint_name = "test_checkconstraint_get_%s" % \
+                                     (str(uuid.uuid4())[1:8])
+        self.check_constraint_id = \
+            check_constraint_utils.create_check_constraint(
+                self.server, self.db_name, self.schema_name, self.table_name,
+                self.check_constraint_name)
+
+        # In case of multiple constraints
+        if self.is_list:
+            self.check_constraint_name = "test_checkconstraint_get_list_%s" % \
+                                         (str(uuid.uuid4())[1:8])
+            self.check_constraint_id = \
+                check_constraint_utils.create_check_constraint(
+                    self.server, self.db_name, self.schema_name,
+                    self.table_name,
+                    self.check_constraint_name)
+
+    def runTest(self):
+        """This function will fetch modified sql for check constraint to
+        table. """
+        if self.is_positive_test:
+            url_encode_data = {"oid": self.check_constraint_id,
+                               "comment": self.data['comment']}
+
+            if 'convalidated' in self.data:
+                url_encode_data["convalidated"] = self.data['convalidated']
+
+            response = check_constraint_utils.api_get_msql(self,
+                                                           url_encode_data)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            self.assertIn(self.data['comment'], response.json['data'])
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_put.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_put.py
index 8ebe5f4e9..2739a4fa3 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_put.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_put.py
@@ -7,8 +7,8 @@
 #
 ##########################################################################
 
-import json
 import uuid
+from unittest.mock import patch
 
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
@@ -19,19 +19,24 @@ from pgadmin.browser.server_groups.servers.databases.tests import utils as \
 from pgadmin.utils.route import BaseTestGenerator
 from regression import parent_node_dict
 from regression.python_test_utils import test_utils as utils
-from . import utils as chk_constraint_utils
+from . import utils as check_constraint_utils
 
 
 class CheckConstraintPutTestCase(BaseTestGenerator):
     """This class will update check constraint to existing table"""
     skip_on_database = ['gpdb']
-    scenarios = [
-        ('Update check constraint to table',
-         dict(url='/browser/check_constraint/obj/'))
-    ]
+    url = '/browser/check_constraint/obj/'
+
+    # Generates scenarios from cast_test_data.json file
+    scenarios = utils.generate_scenarios("check_constraint_put",
+                                         check_constraint_utils.test_cases)
 
     def setUp(self):
         super(CheckConstraintPutTestCase, self).setUp()
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
         self.db_name = parent_node_dict["database"][-1]["db_name"]
         schema_info = parent_node_dict["schema"][-1]
         self.server_id = schema_info["server_id"]
@@ -41,6 +46,8 @@ class CheckConstraintPutTestCase(BaseTestGenerator):
         if not db_con['data']["connected"]:
             raise Exception("Could not connect to database to update a check "
                             "constraint.")
+
+        # Create schema
         self.schema_id = schema_info["schema_id"]
         self.schema_name = schema_info["schema_name"]
         schema_response = schema_utils.verify_schemas(self.server,
@@ -49,36 +56,46 @@ class CheckConstraintPutTestCase(BaseTestGenerator):
         if not schema_response:
             raise Exception("Could not find the schema to update a check "
                             "constraint.")
+
+        # Create table
         self.table_name = "table_checkconstraint_put_%s" % \
                           (str(uuid.uuid4())[1:8])
         self.table_id = tables_utils.create_table(self.server,
                                                   self.db_name,
                                                   self.schema_name,
                                                   self.table_name)
+
+        # Create constraint to modify
         self.check_constraint_name = "test_checkconstraint_put_%s" % \
                                      (str(uuid.uuid4())[1:8])
         self.check_constraint_id = \
-            chk_constraint_utils.create_check_constraint(
+            check_constraint_utils.create_check_constraint(
                 self.server, self.db_name, self.schema_name, self.table_name,
                 self.check_constraint_name)
 
-    def runTest(self):
-        """This function will delete check constraint to table."""
-        chk_constraint = chk_constraint_utils.verify_check_constraint(
+        # Cross check constraint creation
+        chk_constraint = check_constraint_utils.verify_check_constraint(
             self.server, self.db_name, self.check_constraint_name)
         if not chk_constraint:
             raise Exception("Could not find the check constraint to update.")
-        data = {"oid": self.check_constraint_id,
-                "comment": "This is test comment for check constraint."}
-        response = self.tester.put(
-            "{0}{1}/{2}/{3}/{4}/{5}/{6}".format(self.url, utils.SERVER_GROUP,
-                                                self.server_id, self.db_id,
-                                                self.schema_id,
-                                                self.table_id,
-                                                self.check_constraint_id),
-            data=json.dumps(data),
-            follow_redirects=True)
-        self.assertEquals(response.status_code, 200)
+
+    def runTest(self):
+        """This function will update check constraint to table."""
+        self.data["oid"] = self.check_constraint_id
+        if self.is_positive_test:
+            response = check_constraint_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = check_constraint_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
 
     def tearDown(self):
         # Disconnect the database
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_sql.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_sql.py
new file mode 100644
index 000000000..befe174e9
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_sql.py
@@ -0,0 +1,105 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as check_constraint_utils
+
+
+class CheckConstraintGetSqlTestCase(BaseTestGenerator):
+    """This class will fetch check constraint to existing table"""
+    skip_on_database = ['gpdb']
+    url = '/browser/check_constraint/sql/'
+
+    # Generates scenarios from cast_test_data.json file
+    scenarios = utils.generate_scenarios("check_constraint_sql",
+                                         check_constraint_utils.test_cases)
+
+    def setUp(self):
+        super(CheckConstraintGetSqlTestCase, self).setUp()
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        self.server_id = schema_info["server_id"]
+        self.db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to fetch a check "
+                            "constraint.")
+
+        # Create schema
+        self.schema_id = schema_info["schema_id"]
+        self.schema_name = schema_info["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to fetch a check "
+                            "constraint.")
+
+        # Create table
+        self.table_name = "table_checkconstraint_get_%s" % \
+                          (str(uuid.uuid4())[1:8])
+        self.table_id = tables_utils.create_table(self.server,
+                                                  self.db_name,
+                                                  self.schema_name,
+                                                  self.table_name)
+
+        # Create constraint
+        self.check_constraint_name = "test_checkconstraint_get_%s" % \
+                                     (str(uuid.uuid4())[1:8])
+        self.check_constraint_id = \
+            check_constraint_utils.create_check_constraint(
+                self.server, self.db_name, self.schema_name, self.table_name,
+                self.check_constraint_name)
+
+        # Cross check constraint creation
+        chk_constraint = check_constraint_utils.verify_check_constraint(
+            self.server, self.db_name, self.check_constraint_name)
+        if not chk_constraint:
+            raise Exception("Could not find the check constraint to delete.")
+
+    def runTest(self):
+        """This function will fetch sql for check constraint to table."""
+        if self.is_positive_test:
+            response = check_constraint_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = check_constraint_utils.api_get(self)
+            elif 'check_constraint_id' in self.data:
+                # Non-existing constraint id
+                self.check_constraint_id = self.data["check_constraint_id"]
+                response = check_constraint_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_validate.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_validate.py
new file mode 100644
index 000000000..fc43c2fa0
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/test_check_constraint_validate.py
@@ -0,0 +1,95 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as check_constraint_utils
+
+
+class CheckConstraintValidateTestCase(BaseTestGenerator):
+    """This class will validate check constraint to existing table"""
+    skip_on_database = ['gpdb']
+    url = '/browser/check_constraint/validate/'
+
+    # Generates scenarios from cast_test_data.json file
+    scenarios = utils.generate_scenarios("check_constraint_validate",
+                                         check_constraint_utils.test_cases)
+
+    def setUp(self):
+        super(CheckConstraintValidateTestCase, self).setUp()
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        self.server_id = schema_info["server_id"]
+        self.db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to fetch a check "
+                            "constraint.")
+
+        # Create schema
+        self.schema_id = schema_info["schema_id"]
+        self.schema_name = schema_info["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to fetch a check "
+                            "constraint.")
+
+        # Create table
+        self.table_name = "table_checkconstraint_get_%s" % \
+                          (str(uuid.uuid4())[1:8])
+        self.table_id = tables_utils.create_table(self.server,
+                                                  self.db_name,
+                                                  self.schema_name,
+                                                  self.table_name)
+
+        # Create constraint to fetch
+        self.check_constraint_name = "test_checkconstraint_get_%s" % \
+                                     (str(uuid.uuid4())[1:8])
+        self.check_constraint_id = \
+            check_constraint_utils.create_check_constraint(
+                self.server, self.db_name, self.schema_name, self.table_name,
+                self.check_constraint_name)
+
+    def runTest(self):
+        """This function will validate check constraint to table."""
+        if self.is_positive_test:
+            response = check_constraint_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = check_constraint_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/utils.py
index 393b00574..f98e84f4c 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/tests/utils.py
@@ -10,14 +10,83 @@
 
 import sys
 import traceback
+import os
+import json
+from urllib.parse import urlencode
 
 from regression.python_test_utils import test_utils as utils
 
+# Load test data from json file.
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/check_constraint_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+# api call methods
+def api_create(self):
+    return self.tester.post("{0}{1}/{2}/{3}/{4}/{5}/".
+                            format(self.url, utils.SERVER_GROUP,
+                                   self.server_id, self.db_id,
+                                   self.schema_id,
+                                   self.table_id),
+                            data=json.dumps(self.data),
+                            content_type='html/json'
+                            )
+
+
+def api_delete(self, check_constraint_id=None):
+    if check_constraint_id is None:
+        check_constraint_id = self.check_constraint_id
+    return self.tester.delete("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                              format(self.url, utils.SERVER_GROUP,
+                                     self.server_id, self.db_id,
+                                     self.schema_id,
+                                     self.table_id,
+                                     check_constraint_id),
+                              data=json.dumps(self.data),
+                              follow_redirects=True
+                              )
+
+
+def api_get(self, check_constraint_id=None):
+    if check_constraint_id is None:
+        check_constraint_id = self.check_constraint_id
+    return self.tester.get("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id, self.table_id,
+                                  check_constraint_id),
+                           follow_redirects=True
+                           )
+
+
+def api_put(self):
+    return self.tester.put("{0}{1}/{2}/{3}/{4}/{5}/{6}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id, self.table_id,
+                                  self.check_constraint_id),
+                           data=json.dumps(self.data),
+                           follow_redirects=True
+                           )
+
+
+def api_get_msql(self, url_encode_data):
+    return self.tester.get("{0}{1}/{2}/{3}/{4}/{5}/{6}?{7}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.db_id,
+                                  self.schema_id, self.table_id,
+                                  self.check_constraint_id,
+                                  urlencode(url_encode_data)),
+                           follow_redirects=True
+                           )
+
 
 def create_check_constraint(server, db_name, schema_name, table_name,
-                            check_constraint_name):
+                            check_constraint_name, query_val=None):
     """
     This function creates a check constraint under provided table.
+    :param query_val: if you want to have different query
     :param server: server details
     :type server: dict
     :param db_name: database name
@@ -40,12 +109,15 @@ def create_check_constraint(server, db_name, schema_name, table_name,
         old_isolation_level = connection.isolation_level
         connection.set_isolation_level(0)
         pg_cursor = connection.cursor()
-        query = "ALTER TABLE %s.%s ADD CONSTRAINT %s CHECK ( (id > 0)) " \
-                "NOT VALID; COMMENT ON CONSTRAINT %s ON %s.%s IS " \
-                "'this is test comment'" % (schema_name, table_name,
-                                            check_constraint_name,
-                                            check_constraint_name,
-                                            schema_name, table_name)
+        if query_val is None:
+            query = "ALTER TABLE %s.%s ADD CONSTRAINT %s CHECK ( (id > 0)) " \
+                    "NOT VALID; COMMENT ON CONSTRAINT %s ON %s.%s IS " \
+                    "'this is test comment'" % (schema_name, table_name,
+                                                check_constraint_name,
+                                                check_constraint_name,
+                                                schema_name, table_name)
+        else:
+            query = eval(query_val)
         pg_cursor.execute(query)
         connection.set_isolation_level(old_isolation_level)
         connection.commit()
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/tests/test_exclusion_constraint_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/tests/test_exclusion_constraint_add.py
index a521b49c5..a25085bad 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/tests/test_exclusion_constraint_add.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/tests/test_exclusion_constraint_add.py
@@ -9,7 +9,8 @@
 
 import json
 import uuid
-
+from unittest.mock import patch
+from pgadmin.utils import server_utils as server_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
@@ -24,20 +25,36 @@ from . import utils as exclusion_utils
 
 class ExclusionConstraintAddTestCase(BaseTestGenerator):
     """This class will add new exclusion constraint to existing table"""
-    scenarios = [
-        ('Add Exclusion Constraint URL',
-         dict(url='/browser/exclusion_constraint/obj/'))
-    ]
+    url = '/browser/exclusion_constraint/obj/'
+
+    # Generates scenarios from cast_test_data.json file
+    scenarios = utils.generate_scenarios("exclusion_constraint_create",
+                                         exclusion_utils.test_cases)
 
     def setUp(self):
+        # Load test data
+        self.data = self.test_data
+
+        # Create db connection
         self.db_name = parent_node_dict["database"][-1]["db_name"]
         schema_info = parent_node_dict["schema"][-1]
         self.server_id = schema_info["server_id"]
         self.db_id = schema_info["db_id"]
+
+        # Check DB version
+        server_con = server_utils.connect_server(self, self.server_id)
+        if not server_con["info"] == "Server connected.":
+            raise Exception("Could not connect to server to add "
+                            "a table.")
+        self.db_version = server_con["data"]["version"]
+
+        # Create db connection
         db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
                                                  self.server_id, self.db_id)
         if not db_con['data']["connected"]:
             raise Exception("Could not connect to database to add a table.")
+
+        # Create schema
         self.schema_id = schema_info["schema_id"]
         self.schema_name = schema_info["schema_name"]
         schema_response = schema_utils.verify_schemas(self.server,
@@ -45,6 +62,8 @@ class ExclusionConstraintAddTestCase(BaseTestGenerator):
                                                       self.schema_name)
         if not schema_response:
             raise Exception("Could not find the schema to add a table.")
+
+        # Create table
         self.table_name = "table_for_exclusion_%s" % (str(uuid.uuid4())[1:8])
         self.table_id = tables_utils.create_table(self.server, self.db_name,
                                                   self.schema_name,
@@ -52,29 +71,39 @@ class ExclusionConstraintAddTestCase(BaseTestGenerator):
 
     def runTest(self):
         """This function will add exclusion constraint to existing table."""
-        self.index_name = "test_index_add_%s" % (str(uuid.uuid4())[1:8])
-        data = {"name": self.index_name,
-                "spcname": "pg_default",
-                "amname": "btree",
-                "columns": [
-                    {"column": "id", "sort_order": False, "nulls": False,
-                     "operator": "="}],
-                "indconstraint": "(1=2)",
-                "include": ["name"]
-                }
-        response = self.tester.post(
-            self.url + str(utils.SERVER_GROUP) + '/' +
-            str(self.server_id) + '/' + str(self.db_id) +
-            '/' + str(self.schema_id) + '/' + str(self.table_id) + '/',
-            data=json.dumps(data),
-            content_type='html/json')
-        self.assertEquals(response.status_code, 200)
-
-        index_response = exclusion_utils.verify_exclusion_constraint(
-            self.server, self.db_name, self.index_name)
-
-        if not index_response:
-            raise Exception("Could not find the constraint added.")
+        if "name" in self.data:
+            constraint_name = self.data["name"] + (str(uuid.uuid4())[1:8])
+            self.data["name"] = constraint_name
+        elif self.db_version < 110000:
+            constraint_name = self.table_name + '_' + \
+                self.data["columns"][0]['column'] + '_excl'
+        else:
+            constraint_name = self.table_name + '_' + \
+                self.data["columns"][0]['column'] + '_name_excl'
+
+        if self.is_positive_test:
+            response = exclusion_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
+            # Verify in backend
+            cross_check_res = exclusion_utils.verify_exclusion_constraint(
+                self.server, self.db_name, constraint_name)
+            self.assertIsNotNone(cross_check_res,
+                                 "Could not find the newly created exclusion "
+                                 "constraint.")
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=eval(self.mock_data["return_value"])):
+                    response = exclusion_utils.api_create(self)
+            else:
+                response = exclusion_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
 
     def tearDown(self):
         # Disconnect the database
